<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><link rel="canonical" href="https://example.com/beacon-aggregator/" />
      <link rel="shortcut icon" href="../img/favicon.ico" />
    <title>Aggregator - ELIXIR Beacon v2 Network Documentation</title>
    <link rel="stylesheet" href="../css/theme.css" />
    <link rel="stylesheet" href="../css/theme_extra.css" />
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/10.5.0/styles/github.min.css" />
    
      <script>
        // Current page data
        var mkdocs_page_name = "Aggregator";
        var mkdocs_page_input_path = "beacon-aggregator.md";
        var mkdocs_page_url = "/beacon-aggregator/";
      </script>
    
    <script src="../js/jquery-3.6.0.min.js" defer></script>
    <!--[if lt IE 9]>
      <script src="../js/html5shiv.min.js"></script>
    <![endif]-->
      <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/10.5.0/highlight.min.js"></script>
      <script>hljs.initHighlightingOnLoad();</script> 
</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side stickynav">
    <div class="wy-side-scroll">
      <div class="wy-side-nav-search">
          <a href=".." class="icon icon-home"> ELIXIR Beacon v2 Network Documentation
        </a><div role="search">
  <form id ="rtd-search-form" class="wy-form" action="../search.html" method="get">
      <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" title="Type search term here" />
  </form>
</div>
      </div>

      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="..">Home</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../light-beacon-network/">Light a Beacon Network</a>
                </li>
              </ul>
              <ul class="current">
                <li class="toctree-l1 current"><a class="reference internal current" href="./">Aggregator</a>
    <ul class="current">
    <li class="toctree-l2"><a class="reference internal" href="#meta-beacon">Meta-Beacon</a>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#query-policies">Query Policies</a>
    </li>
    </ul>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../beacon-registry/">Registry</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../best-practices/">Best practices</a>
                </li>
              </ul>
      </div>
    </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
      <nav class="wy-nav-top" role="navigation" aria-label="Mobile navigation menu">
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="..">ELIXIR Beacon v2 Network Documentation</a>
        
      </nav>
      <div class="wy-nav-content">
        <div class="rst-content"><div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href=".." class="icon icon-home" aria-label="Docs"></a> &raquo;</li>
      <li>Aggregator</li>
    <li class="wy-breadcrumbs-aside">
    </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
            <div class="section" itemprop="articleBody">
              
                <h1 id="beacon-aggregator">Beacon Aggregator</h1>
<p>The Beacon aggregator (BA) is the agent in charge of querying the Beacons in the network and gathering the results. It also aggregates and parses their metadata.</p>
<h2 id="meta-beacon">Meta-Beacon</h2>
<p>The Beacon Aggregator is itself a standard Beacon v2. As it is created to query other Beacons, it is referred to as Meta-Beacon.
In order to differentiate the Meta-Beacon to a simple Beacon, and to have the aggregation functionalities, we have listed the following additional properties:</p>
<ul>
<li>isBeaconNetwork: Property used to </li>
<li>beaconId:</li>
</ul>
<h2 id="query-policies">Query Policies</h2>
<p>The Beacon aggregator sends the query to the multiple Beacons in the network. To reduce to the minimum the queries sent, thus reducing the payload of the server, it follows these policies:
 - First, if a Beacon requires authentication, the BA must provide a header with the authentication of the user to the given Beacon. If the authentication is not needed, it goes to the next step.</p>
<ul>
<li>
<p>The BA parses the /map endpoint and looks if the Beacon has the model schema needed (individuals, biosamples, etc).</p>
</li>
<li>
<p>Check if the filtering terms of the query exists.</p>
</li>
<li>In the network, there can be Beacons with different schemas, such as Phenopackets or different versions of Beacon. If the network is not able to read these schemas, it must quit the query for the given Beacon.</li>
</ul>
<p><img alt="Diagram query policies" src="../images/diagram_aggregator.png" /></p>
              
            </div>
          </div><footer>
    <div class="rst-footer-buttons" role="navigation" aria-label="Footer Navigation">
        <a href="../light-beacon-network/" class="btn btn-neutral float-left" title="Light a Beacon Network"><span class="icon icon-circle-arrow-left"></span> Previous</a>
        <a href="../beacon-registry/" class="btn btn-neutral float-right" title="Registry">Next <span class="icon icon-circle-arrow-right"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <!-- Copyright etc -->
  </div>

  Built with <a href="https://www.mkdocs.org/">MkDocs</a> using a <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>.
</footer>
          
        </div>
      </div>

    </section>

  </div>

  <div class="rst-versions" role="note" aria-label="Versions">
  <span class="rst-current-version" data-toggle="rst-current-version">
    
    
      <span><a href="../light-beacon-network/" style="color: #fcfcfc">&laquo; Previous</a></span>
    
    
      <span><a href="../beacon-registry/" style="color: #fcfcfc">Next &raquo;</a></span>
    
  </span>
</div>
    <script>var base_url = '..';</script>
    <script src="../js/theme_extra.js" defer></script>
    <script src="../js/theme.js" defer></script>
      <script src="../search/main.js" defer></script>
    <script defer>
        window.onload = function () {
            SphinxRtdTheme.Navigation.enable(true);
        };
    </script>

</body>
</html>
